<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TemplateInstantiation xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/core/templates/TemplateInstantiation.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.core.templates;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EObject;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.resource.Resource;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.ElementUtils;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.TransformationException;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.Messages;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.LazyCopier;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.LazyCopier.CopyStatus;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.TransformationContext;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.filters.FilterSignatures;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Namespace;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ParameterableElement;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateBinding;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateParameter;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateParameterSubstitution;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateSignature;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateableElement;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <em class="jxr_javadoccomment"> * This class encapsulates functions around template instantiation.</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <em class="jxr_javadoccomment"> * With respect to composite structures, we need to consider two different</em>
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <em class="jxr_javadoccomment"> * cases: (1) the type of a property is a template class itself (2) the type of</em>
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <em class="jxr_javadoccomment"> * a property is a sub-class (nesting) of the template class. We consider that</em>
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <em class="jxr_javadoccomment"> * such a class inherits the template signature of its owner, i.e. it can access</em>
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <em class="jxr_javadoccomment"> * formal parameters of the owning template class. (3) the type of a property is</em>
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <em class="jxr_javadoccomment"> * a normal class</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/templates/TemplateInstantiation.html">TemplateInstantiation</a> {
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment">	 * Convenience constructor, take copier from transformation context.</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment">	 * @param binding</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment">	 * @throws TransformationException</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/templates/TemplateInstantiation.html">TemplateInstantiation</a>(TemplateBinding binding) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  		<strong class="jxr_keyword">this</strong>(TransformationContext.current.copier, binding);
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  	}
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <em class="jxr_javadoccomment">	 * Create a new template instantiation from a given copier and binding</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <em class="jxr_javadoccomment">	 * @param copier</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <em class="jxr_javadoccomment">	 *            a lazy copier</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  <em class="jxr_javadoccomment">	 * @param binding</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  <em class="jxr_javadoccomment">	 *            a template binding (formal-&gt;actual mapping)</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  <em class="jxr_javadoccomment">	 * @throws TransformationException</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/templates/TemplateInstantiation.html">TemplateInstantiation</a>(<a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/transformations/LazyCopier.html">LazyCopier</a> copier, TemplateBinding binding) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  		<strong class="jxr_keyword">if</strong> (binding == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  			<em class="jxr_comment">// user should never see this exception</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> TransformationException(<span class="jxr_string">"Passed binding is null"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  		}
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  		<strong class="jxr_keyword">this</strong>.copier = copier;
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  		signature = binding.getSignature();
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  		<strong class="jxr_keyword">if</strong> (signature == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> TransformationException(<span class="jxr_string">"Passed template binding does not have a signature"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  		}
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  		packageTemplate = (Package) signature.getOwner();
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  		Package boundPackage = (Package) binding.getBoundElement();
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		<em class="jxr_comment">// set template instantiation parameter. Used by xtend templates to get relation between</em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  		<em class="jxr_comment">// formal and actual parameters</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  		context = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/templates/InstantiationContext.html">InstantiationContext</a>(<strong class="jxr_keyword">this</strong>);
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  		copier.setPackageTemplate(packageTemplate, boundPackage);
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  		<em class="jxr_comment">// some parameters of the package template may not be owned. Thus, an additional package</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  		<em class="jxr_comment">// template is involved in the instantiation</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  		<strong class="jxr_keyword">for</strong> (TemplateParameter parameter : signature.getParameters()) {
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  			<em class="jxr_comment">//</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  			<strong class="jxr_keyword">if</strong> (parameter.getSignature() != signature) {
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  				Package addedPkgTemplate = parameter.getSignature().getNearestPackage();
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  				copier.setPackageTemplate(addedPkgTemplate, boundPackage);
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  			}
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  		}
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  		<strong class="jxr_keyword">if</strong> (boundPackage.getPackagedElements() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  			<em class="jxr_comment">// bound package is not empty, but copier does not know about it. Fill copyMap with information about the relation</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  			<em class="jxr_comment">// This happens, if the original model already contains template instantiations, e.g. for template ports</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  			<strong class="jxr_keyword">if</strong> (copier.getMap(signature).keySet().size() == 0) {
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  				sourceResource = packageTemplate.eResource();
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 				targetResource = boundPackage.eResource();
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 				syncCopyMap(packageTemplate, boundPackage);
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 			}
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 			<em class="jxr_comment">// syncCopy map would not be necessary, if ports are not updated (by a listener?) during copier)</em>
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		}
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		<strong class="jxr_keyword">this</strong>.binding = binding;
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 		<em class="jxr_comment">// register a combination of formal/actual in the hashmap</em>
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<em class="jxr_comment">// =&gt; copier will replace actual with formal</em>
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 		<strong class="jxr_keyword">for</strong> (TemplateParameterSubstitution substitution : binding.getParameterSubstitutions()) {
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 			ParameterableElement formal = substitution.getFormal().getParameteredElement();
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 			ParameterableElement actual = substitution.getActual();
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 			copier.putPair(formal, actual);
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 		}
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		<em class="jxr_comment">// add copy listeners ---</em>
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 		<em class="jxr_comment">// remove template signature</em>
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 		<strong class="jxr_keyword">if</strong> (!copier.preCopyListeners.contains(FilterSignatures.getInstance())) {
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 			copier.preCopyListeners.add(FilterSignatures.getInstance());
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 		}
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		<em class="jxr_comment">// 2a. special treatment for elements stereotyped with template parameter</em>
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		<strong class="jxr_keyword">if</strong> (!copier.preCopyListeners.contains(PreTemplateInstantiationListener.getInstance())) {
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 			copier.preCopyListeners.add(PreTemplateInstantiationListener.getInstance());
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		}
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 		PreTemplateInstantiationListener.getInstance().init(copier, binding);
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 		<em class="jxr_comment">// 2b. special treatment for elements stereotyped with template parameter</em>
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 		<strong class="jxr_keyword">if</strong> (!copier.postCopyListeners.contains(PostTemplateInstantiationListener.getInstance())) {
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 			copier.postCopyListeners.add(PostTemplateInstantiationListener.getInstance());
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 		}
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L128" href="#L128">128</a> <em class="jxr_comment">		 * PostTemplateInstantiationListener.getInstance().init(copier, binding);</em>
<a class="jxr_linenumber" name="L129" href="#L129">129</a> <em class="jxr_comment">		 * if(!copier.postCopyListeners.contains(FixTemplateSync.getInstance())) {</em>
<a class="jxr_linenumber" name="L130" href="#L130">130</a> <em class="jxr_comment">		 * copier.postCopyListeners.add(FixTemplateSync.getInstance());</em>
<a class="jxr_linenumber" name="L131" href="#L131">131</a> <em class="jxr_comment">		 * }</em>
<a class="jxr_linenumber" name="L132" href="#L132">132</a> <em class="jxr_comment">		 */</em>
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 	}
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L136" href="#L136">136</a> <em class="jxr_javadoccomment">	 * Synchronize the copy map, i.e. put the correspondences between existing source and target elements into the map.</em>
<a class="jxr_linenumber" name="L137" href="#L137">137</a> <em class="jxr_javadoccomment">	 * Otherwise, a new binding would produce duplicates.</em>
<a class="jxr_linenumber" name="L138" href="#L138">138</a> <em class="jxr_javadoccomment">	 * TODO: A more efficient way would be to cache the copy function and only re-sync, if a new model has been loaded.</em>
<a class="jxr_linenumber" name="L139" href="#L139">139</a> <em class="jxr_javadoccomment">	 * On the other hand, the bound package is normally not very large</em>
<a class="jxr_linenumber" name="L140" href="#L140">140</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L141" href="#L141">141</a> <em class="jxr_javadoccomment">	 * @param source</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> <em class="jxr_javadoccomment">	 *            An element of the source model</em>
<a class="jxr_linenumber" name="L143" href="#L143">143</a> <em class="jxr_javadoccomment">	 * @param targetPkg</em>
<a class="jxr_linenumber" name="L144" href="#L144">144</a> <em class="jxr_javadoccomment">	 *            The associated element of the target model</em>
<a class="jxr_linenumber" name="L145" href="#L145">145</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> syncCopyMap(EObject source, EObject targetPkg) {
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 		<strong class="jxr_keyword">if</strong> ((copier.get(source) == <strong class="jxr_keyword">null</strong>) || copier.getStatus(targetPkg) != CopyStatus.FULL) {
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 			copier.put(source, targetPkg);
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 			<strong class="jxr_keyword">if</strong> (source instanceof Package) {
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 				copier.setStatus(targetPkg, CopyStatus.SHALLOW);
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 				copier.setStatus(targetPkg, CopyStatus.FULL);
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 			}
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 			<strong class="jxr_keyword">for</strong> (EObject targetSubElem : targetPkg.eContents()) {
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 				EObject sourceSubElement = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 				<strong class="jxr_keyword">if</strong> (targetSubElem instanceof NamedElement) {
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 					String targetName = ((NamedElement) targetSubElem).getName();
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 					sourceSubElement = ElementUtils.getNamedElementFromList(source.eContents(), targetName);
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 				}
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 				<strong class="jxr_keyword">if</strong> (sourceSubElement == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 					<em class="jxr_comment">// no source element found, try to find via XML URI (copier synchronizes on demand)</em>
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 					String uriFragment = targetResource.getURIFragment(targetSubElem);
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 					sourceSubElement = sourceResource.getEObject(uriFragment);
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 				}
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 				<strong class="jxr_keyword">if</strong> (sourceSubElement != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 					syncCopyMap(sourceSubElement, targetSubElem);
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 				}
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 			}
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 		}
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 	}
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 	Package packageTemplate;
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 	<strong class="jxr_keyword">public</strong> TemplateBinding binding;
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 	<strong class="jxr_keyword">protected</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/transformations/LazyCopier.html">LazyCopier</a> copier;
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 	<strong class="jxr_keyword">protected</strong> TemplateSignature signature;
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 	<strong class="jxr_keyword">protected</strong> Resource sourceResource;
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 	<strong class="jxr_keyword">protected</strong> Resource targetResource;
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L185" href="#L185">185</a> <em class="jxr_javadoccomment">	 * Bind a named element. Besides of binding the passed element, this</em>
<a class="jxr_linenumber" name="L186" href="#L186">186</a> <em class="jxr_javadoccomment">	 * operation will bind all elements that are referenced (required) by the</em>
<a class="jxr_linenumber" name="L187" href="#L187">187</a> <em class="jxr_javadoccomment">	 * passed element.</em>
<a class="jxr_linenumber" name="L188" href="#L188">188</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L189" href="#L189">189</a> <em class="jxr_javadoccomment">	 * In consequence, typically only a small part of a package template is</em>
<a class="jxr_linenumber" name="L190" href="#L190">190</a> <em class="jxr_javadoccomment">	 * actually created within the bound package. We call this mechanism lazy</em>
<a class="jxr_linenumber" name="L191" href="#L191">191</a> <em class="jxr_javadoccomment">	 * instantiation/binding</em>
<a class="jxr_linenumber" name="L192" href="#L192">192</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L193" href="#L193">193</a> <em class="jxr_javadoccomment">	 * @param copier</em>
<a class="jxr_linenumber" name="L194" href="#L194">194</a> <em class="jxr_javadoccomment">	 *            Source and target model</em>
<a class="jxr_linenumber" name="L195" href="#L195">195</a> <em class="jxr_javadoccomment">	 * @param namedElement</em>
<a class="jxr_linenumber" name="L196" href="#L196">196</a> <em class="jxr_javadoccomment">	 *            A member within the package template which should be bound,</em>
<a class="jxr_linenumber" name="L197" href="#L197">197</a> <em class="jxr_javadoccomment">	 *            i.e. for which template instantiation should be performed.</em>
<a class="jxr_linenumber" name="L198" href="#L198">198</a> <em class="jxr_javadoccomment">	 * @param binding</em>
<a class="jxr_linenumber" name="L199" href="#L199">199</a> <em class="jxr_javadoccomment">	 *            The binding between the bound package and the package template</em>
<a class="jxr_linenumber" name="L200" href="#L200">200</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 	@SuppressWarnings(<span class="jxr_string">"unchecked"</span>)
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 	<strong class="jxr_keyword">public</strong> &lt;T <strong class="jxr_keyword">extends</strong> Element&gt; T bindElement(T namedElement) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 		<strong class="jxr_keyword">if</strong> (namedElement == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 			<em class="jxr_comment">// user should never see this exception</em>
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> TransformationException(Messages.TemplateInstantiation_TemplateIsNull);
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 		}
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 		Package boundPackage = (Package) binding.getBoundElement();
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 		EList&lt;Namespace&gt; path = TemplateUtils.relativePathWithMerge(namedElement, packageTemplate);
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 		<strong class="jxr_keyword">if</strong> (path != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 			<em class="jxr_comment">// register owning package template (template can be defined in</em>
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 			<em class="jxr_comment">// multiple packages)</em>
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 			Element owner = TemplateUtils.getTemplateOwner(namedElement, signature);
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 			<strong class="jxr_keyword">if</strong> (owner != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 				<em class="jxr_comment">// note that we might overwrite an existing value</em>
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 				copier.put(owner, boundPackage);
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 			}
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 			<em class="jxr_comment">// element is not part of the package template referenced by the</em>
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 			<em class="jxr_comment">// binding</em>
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 			<strong class="jxr_keyword">if</strong> (namedElement instanceof TemplateableElement) {
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 				<em class="jxr_comment">// check whether the referenced element is part of another</em>
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 				<em class="jxr_comment">// package template,</em>
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 				<em class="jxr_comment">// (for which we allow for implicit binding with the first</em>
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 				<em class="jxr_comment">// template parameter)</em>
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 				TemplateSignature signatureOfNE = TemplateUtils.getSignature((TemplateableElement) namedElement);
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 				<strong class="jxr_keyword">if</strong> ((signatureOfNE != <strong class="jxr_keyword">null</strong>) &amp;&amp; (signature != signatureOfNE)) {
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 					TemplateBinding subBinding = TemplateUtils.getSubBinding(copier.target, (TemplateableElement) namedElement, binding);
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 					TemplateInstantiation ti = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/templates/TemplateInstantiation.html">TemplateInstantiation</a>(subBinding);
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 					Element ret = ti.bindElement(namedElement);
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 					<strong class="jxr_keyword">return</strong> (T) ret;
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 				}
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 			}
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 			<em class="jxr_comment">// =&gt; nothing to do with respect to template instantiation, but</em>
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 			<em class="jxr_comment">// since the template is potentially instantiated in another model,</em>
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 			<em class="jxr_comment">// the referenced element might need to be copied.</em>
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 			<strong class="jxr_keyword">return</strong> copier.getCopy(namedElement);
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 		}
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 		<em class="jxr_comment">// element is contained in the template package, examine whether it</em>
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 		<em class="jxr_comment">// already exists in the</em>
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 		<em class="jxr_comment">// bound package.</em>
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 		NamedElement existingMember = (NamedElement) copier.get(namedElement);
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 		<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L244" href="#L244">244</a> <em class="jxr_comment">		 * if((existingMember != null) &amp;&amp; (templateKind != TemplateKind.ACCUMULATE)) {</em>
<a class="jxr_linenumber" name="L245" href="#L245">245</a> <em class="jxr_comment">		 * // element is already existing (and thus bound), nothing to do</em>
<a class="jxr_linenumber" name="L246" href="#L246">246</a> <em class="jxr_comment">		 * // additional check, whether the ACCUMULATE information is unset)</em>
<a class="jxr_linenumber" name="L247" href="#L247">247</a> <em class="jxr_comment">		 * // however: if the element is a package, existence is not sufficient</em>
<a class="jxr_linenumber" name="L248" href="#L248">248</a> <em class="jxr_comment">		 * // since it might have been created via getAndCreate above</em>
<a class="jxr_linenumber" name="L249" href="#L249">249</a> <em class="jxr_comment">		 *</em>
<a class="jxr_linenumber" name="L250" href="#L250">250</a> <em class="jxr_comment">		 * //if(namedElement instanceof Package) {</em>
<a class="jxr_linenumber" name="L251" href="#L251">251</a> <em class="jxr_comment">		 * // bindPackage((Package)namedElement);</em>
<a class="jxr_linenumber" name="L252" href="#L252">252</a> <em class="jxr_comment">		 * //}</em>
<a class="jxr_linenumber" name="L253" href="#L253">253</a> <em class="jxr_comment">		 * return (T)existingMember;</em>
<a class="jxr_linenumber" name="L254" href="#L254">254</a> <em class="jxr_comment">		 * }</em>
<a class="jxr_linenumber" name="L255" href="#L255">255</a> <em class="jxr_comment">		 */</em>
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 		<strong class="jxr_keyword">if</strong> (existingMember == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 			T copiedElement = copier.getCopy(namedElement);
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 			copier.setPackageTemplate(<strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 			<strong class="jxr_keyword">return</strong> copiedElement;
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 		}
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 		<strong class="jxr_keyword">return</strong> (T) existingMember;
<a class="jxr_linenumber" name="L262" href="#L262">262</a> 	}
<a class="jxr_linenumber" name="L263" href="#L263">263</a> 
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/templates/InstantiationContext.html">InstantiationContext</a> context;
<a class="jxr_linenumber" name="L265" href="#L265">265</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
